# Demo IPOL: A Study of RobustNet, a Domain Generalization Method for Semantic Segmentation

This repository constitutes the source code of the provided [demo IPOL](https://ipolcore.ipol.im/demo/clientApp/demo.html?id=433) of this IPOL MLBriefs article. The following instructions are aimed to run the code and reproduce the experiments described in the publication.

## Requirements :
```Shell
numpy
matplotlib
plotly
imageio
pandas
torch
torchvision
kmeans1d
```

## Download pre-trained weights
You can download the pre-trained model weights from the supplementary material or directly from the [official code of the method](https://github.com/shachoi/RobustNet). You can select a baseline model and the RobustNet model (named ours_isw in the google drive provided by the authors) pre-trained in the desired dataset.

## Load the pre-trained models
Use the file get_pretrained_models.py to load the downloaded models. Provide the paths to both the baseline and ISW models as follows:
```Shell
model_base, model_isw = get_pretrained_models.load_pretrained_models(BASELINE_PATH, ISW_PATH)
```

## Inference
Load an image and run inference on each of the models as shown in the code below, which saves each of the predicted segmentation maps.

```Shell
img = imageio.imread(img_path)

prediction_base = get_pretrained_models.predict(model_base, img)
imageio.imsave("output_base.png", prediction_base)

prediction_isw = get_pretrained_models.predict(model_isw, img)
imageio.imsave("output_isw.png", prediction_isw)
```

## Contact
Email: xavier.bou_hernandez@ens-paris-saclay.fr
